barplot(dpois(0:5,0.5),xlab="y",ylab="Probability",names=0:5,main="mean = 0.5")
barplot(dpois(0:10,2),xlab="y",ylab="Probability",names=0:10,main="mean = 2")
barplot(dpois(0:15,5),xlab="y",ylab="Probability",names=0:15,main="mean = 5")
data(gala, package="faraway")
gala <- gala[,-2]
modl <- lm(Species ~ . , gala)
plot(modl, 1)
modt <- lm(sqrt(Species) ~ . , gala)
plot(modt, 1)
library(faraway)
sumary(modt)
modp <- glm(Species ~ ., family=poisson, gala)
sumary(modp)
halfnorm(residuals(modp))
plot(log(fitted(modp)),log((gala$Species-fitted(modp))^2), xlab=expression(hat(mu)),ylab=expression((y-hat(mu))^2))
abline(0,1)
(dp <- sum(residuals(modp,type="pearson")^2)/modp$df.res)
sumary(modp,dispersion=dp)
modd <- glm(Species ~ ., family=quasipoisson, gala)
drop1(modd,test="F")
data(dicentric, package="faraway")
round(xtabs(ca/cells ~ doseamt+doserate, dicentric),2)
with(dicentric,interaction.plot(doseamt, doserate, ca/cells, legend=FALSE))
lmod <- lm(ca/cells ~ log(doserate)*factor(doseamt), dicentric)
summary(lmod)$adj
plot(residuals(lmod) ~ fitted(lmod),xlab="Fitted",ylab="Residuals")
abline(h=0)
dicentric$dosef <- factor(dicentric$doseamt)
pmod <- glm(ca ~ log(cells)+log(doserate)*dosef,  family=poisson,dicentric)
sumary(pmod)
rmod <- glm(ca ~ offset(log(cells))+log(doserate)*dosef,  family=poisson,dicentric)
sumary(rmod)
data(solder, package="faraway")
modp <- glm(skips ~ . , family=poisson, data=solder)
c(deviance(modp), df.residual(modp))
modp2  <- glm(skips ~ (Opening +Solder + Mask + PadType + Panel)^2 ,  family=poisson, data=solder)
deviance(modp2)
pchisq(deviance(modp2),df.residual(modp2),lower=FALSE)
library(MASS)
modn <- glm(skips ~ .,negative.binomial(1),solder)
modn
modn <- glm.nb(skips ~ .,solder)
summary(modn)
library(pscl)
modp <- glm(art ~ ., data=bioChemists, family=poisson)
sumary(modp)
ocount <- table(bioChemists$art)[1:8]
pcount <- colSums(predprob(modp)[,1:8])
plot(pcount,ocount,type="n",xlab="Predicted",ylab="Observed")
text(pcount,ocount, 0:7)
modh <- hurdle(art ~ ., data=bioChemists)
summary(modh)
modz <- zeroinfl(art ~ ., data=bioChemists)
summary(modz)
plot(fitted(modh), fitted(modz), xlab="Hurdle predictions", ylab="ZIP predictions")
abline(0,1)
modz2 <- zeroinfl(art ~ fem+kid5+ment | ment, data=bioChemists)
summary(modz2)
(lrt <- 2*(modz$loglik-modz2$loglik))
1-pchisq(6.1728,6)
exp(coef(modz2))
newman <- data.frame(fem="Men",mar="Single",kid5=0,ment=6)
predict(modz2, newdata=newman, type="prob")
predict(modz2, newdata=newman, type="zero")
